SystemOrganization addCategory: #'Xenon-Core'!
SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Translators'!
SystemOrganization addCategory: #'Xenon-Core-UI'!
SystemOrganization addCategory: #'Xenon-Core-Semantic'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Binding'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Scope'!
SystemOrganization addCategory: #'Xenon-Core-Semantic-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core-Util'!

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/5/2012 15:47'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:
! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/22/2012 00:59'!
asXeType
	^ XeType name: self asString
	! !

!String methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 20:57'!
asCLiteralValue
 	^ '"', self, '"'
	! !

!SmallInteger methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:39'!
asCLiteralValue
	^ self asString
	! !

Notification subclass: #XeUndeclaredVariableNotification
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeUndeclaredVariableNotification commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeUndeclaredVariableNotification class methodsFor: 'signalling' stamp: 'BernardoContreras 4/14/2012 21:13'!
node: aVariableNode
	^ self new
		node: aVariableNode;
		signal: aVariableNode name , ' is undeclared'! !

!XeUndeclaredVariableNotification methodsFor: 'exceptiondescription' stamp: 'BernardoContreras 4/15/2012 01:57'!
defaultAction
	^ XeUndeclaredBinding node: self node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node
	^ node! !

!XeUndeclaredVariableNotification methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 21:13'!
node: aNode
	node := aNode! !

RBProgramNodeVisitor subclass: #XeFunctionPrototypeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translators'!

!XeFunctionPrototypeTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write function prototypes on a stream.
!

!XeFunctionPrototypeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/6/2012 21:06'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 00:51'!
acceptMethodNode: aMethodNode
	aMethodNode scope returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitArguments: aMethodNode arguments.
	self nextPut: $); nextPut: $;; cr.! !

!XeFunctionPrototypeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/13/2012 03:56'!
acceptVariableNode: aVariableNode
	aVariableNode type emitOn: stream.
	self space.
	self nextPutAll: aVariableNode name! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
cr
	stream cr! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPut: anObject
	stream nextPut: anObject! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:16'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeFunctionPrototypeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/6/2012 22:15'!
space
	stream space! !

!XeFunctionPrototypeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/6/2012 21:10'!
stream: aStream 
	stream := aStream! !

!XeFunctionPrototypeTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/8/2012 19:43'!
visitArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

RBProgramNodeVisitor subclass: #XeMethodTranslator
	instanceVariableNames: 'stream indentationLevel translationDict beginningOfLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translators'!

!XeMethodTranslator commentStamp: 'BernardoContreras 4/7/2012 18:42' prior: 0!
To write functions on a stream
!

!XeMethodTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/7/2012 02:16'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/30/2012 23:52'!
acceptBlockNode: aBlockNode
	self incrementIndentation.
	self
		nextPut: ${;
		cr.
	self visitArguments: aBlockNode arguments.
	aBlockNode isConditionalBlock
		ifTrue: [ 
			| lastStmt |
			lastStmt := aBlockNode body statements removeLast.
			self visitNode: aBlockNode body.
			self nextPutAll: 'if ('.
			aBlockNode isTrueBlock
				ifTrue: [ 
					self nextPutAll: '!!('.
					self visitNode: lastStmt.
					self nextPut: $) ]
				ifFalse: [ self visitNode: lastStmt ].
			self
				nextPutAll: ') break;';
				cr ]
		ifFalse: [ self visitNode: aBlockNode body ].
	self nextPut: $}.
	self decrementIndentation! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/11/2012 22:46'!
acceptLiteralNode: aLiteralNode
	self nextPutAll: aLiteralNode token value asCLiteralValue! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/13/2012 05:07'!
acceptMessageNode: aMessageNode
	(self translateBuiltinMessageFor: aMessageNode)
		ifTrue: [ ^ self ].
	(aMessageNode isCascaded not or: [ aMessageNode isFirstCascaded ])
		ifTrue: [ self visitNode: aMessageNode receiver ].
	aMessageNode isBinary
		ifTrue: [ 
			self space.
			self nextPutAll: aMessageNode selector.
			self space.
			aMessageNode arguments do: [ :each | self visitNode: each ] ].
	aMessageNode isKeyword
		ifTrue: [ 
			stream nextPutAll: aMessageNode cFunctionName.
			self nextPut: $(.
			aMessageNode arguments do: [ :each | self visitNode: each ] separatedBy: [ self nextPutAll: ', ' ].
			self nextPut: $) ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/30/2012 23:19'!
acceptMethodNode: aMethodNode
	aMethodNode scope returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitMethodArguments: aMethodNode arguments.
	self
		nextPutAll: '){';
		cr.
	self incrementIndentation.
	self visitNode: aMethodNode body.
	self decrementIndentation.
	self
		nextPut: $};
		cr! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/30/2012 23:19'!
acceptReturnNode: aReturnNode
	aReturnNode scope returnType = #void asXeType
		ifTrue: [ 
			self visitNode: aReturnNode value.
			self endsWithClosingBracket
				ifFalse: [ self nextPut: $; ].
			self cr.
			self nextPutAll: 'return' ]
		ifFalse: [ 
			self
				nextPutAll: 'return';
				space.
			self visitNode: aReturnNode value ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/30/2012 23:16'!
acceptSequenceNode: aSequenceNode
	"self visitArguments: aSequenceNode temporaries."

	aSequenceNode statements
		do: [ :each | 
			self visitNode: each.
			self endsWithClosingBracket
				ifFalse: [ self nextPut: $; ].
			self cr ]! !

!XeMethodTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/13/2012 03:55'!
acceptVariableNode: aVariableNode
	aVariableNode xeVariableBinding isArgumentBinding
		ifTrue: [ 
			aVariableNode parent isMethod
				ifTrue: [ 
					aVariableNode type emitOn: stream.
					self space ] ].
	aVariableNode xeVariableBinding isSelfBinding
		ifFalse: [ self nextPutAll: aVariableNode name ]! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/30/2012 23:26'!
cr
	stream cr.
	beginningOfLine := true! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/13/2012 05:04'!
endsWithClosingBracket
	"Answer true if the stream ends in a $} character."

	| ch pos |
	(pos := stream position) > 0
		ifTrue: [ 
			stream position: pos - 1.
			ch := stream next.
			^ ch = $} ].
	^ false! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/7/2012 02:16'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeMethodTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/12/2012 18:21'!
initialize
	super initialize.
	indentationLevel := 0.
	beginningOfLine := true.
	self initializeTranslationDictionary! !

!XeMethodTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/12/2012 20:24'!
initializeTranslationDictionary
	translationDict := Dictionary new: 200.
	translationDict at: #ifTrue: put: #translateIfTrueFor:.
	translationDict at: #ifTrue:ifFalse: put: #translateIfTrueIfFalseFor:.
	translationDict at: #ifFalse: put: #translateIfFalseFor:.
	translationDict at: #ifFalse:ifTrue: put: #translateIfFalseIfTrueFor:.
	translationDict at: #whileTrue: put: #translateWhileTrueDoFor:.
	translationDict at: #doWhileTrue: put: #translateDoWhileTrueFor:.
	translationDict at: #whileTrue put: #translateWhileTrueFor:.
	translationDict at: #whileFalse: put: #translateWhileFalseDoFor:.
	translationDict at: #doWhileFalse: put: #translateDoWhileFalseFor:.
	translationDict at: #whileFalse put: #translateWhileFalseFor:! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/30/2012 23:24'!
nextPut: anObject
	self nextPutIndentation.
	stream nextPut: anObject! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/30/2012 23:25'!
nextPutAll: aCollection
	self nextPutIndentation.
	stream nextPutAll: aCollection! !

!XeMethodTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 5/1/2012 15:33'!
nextPutIndentation
	beginningOfLine
		ifFalse: [ ^ self ].
	stream tab: indentationLevel.
	beginningOfLine := false! !

!XeMethodTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/7/2012 02:16'!
space
	stream space! !

!XeMethodTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:16'!
stream: aStream 
	stream := aStream! !

!XeMethodTranslator methodsFor: 'private utilities' stamp: 'BernardoContreras 4/13/2012 00:15'!
translateBuiltinMessageFor: aMessageNode
	"If the given selector is in the translation dictionary, translate it into a target code construct and return true. Otherwise, do nothing and return false."

	| action |
	action := translationDict at: aMessageNode selector ifAbsent: [ ^ false ].
	self perform: action with: aMessageNode.
	^ true! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/20/2012 17:11'!
translateDoWhileFalseFor: aMessageNode
	self nextPutAll: 'do '.
	aMessageNode arguments first beFalseBlock.
	aMessageNode receiver addLastStmt: aMessageNode arguments first.
	self visitArguments: aMessageNode receiver.
	self nextPutAll: ' while (1)'! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/20/2012 17:29'!
translateDoWhileTrueFor: aMessageNode
	self nextPutAll: 'do '.
	aMessageNode arguments first beTrueBlock.
	aMessageNode receiver addLastStmt: aMessageNode arguments first.
	self visitArguments: aMessageNode receiver.
	self nextPutAll: ' while (1)'! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/16/2012 22:40'!
translateIfFalseFor: aMessageNode
	aMessageNode parent isSequence
		ifTrue: [ 
			self nextPutAll: 'if (!!('.
			self visitNode: aMessageNode receiver.
			self nextPutAll: ')) '.
			self visitArguments: aMessageNode arguments ]
		ifFalse: [ 
			self nextPutAll: '(!!('.
			self visitNode: aMessageNode receiver.
			self nextPutAll: ') ? '.
			self visitArguments: aMessageNode arguments first lastStmt.
			self nextPutAll: ' : 0)' ]! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/13/2012 04:47'!
translateIfFalseIfTrueFor: aMessageNode
	self nextPutAll: 'if (!!('.
	self visitNode: aMessageNode receiver.
	self nextPutAll: ')) '.
	self visitArguments: aMessageNode arguments first.
	self nextPutAll: ' else '.
	self visitArguments: aMessageNode arguments second! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/20/2012 16:47'!
translateIfTrueFor: aMessageNode
	aMessageNode parent isSequence
		ifTrue: [ 
			self nextPutAll: 'if ('.
			self visitNode: aMessageNode receiver.
			self nextPutAll: ') '.
			self visitArguments: aMessageNode arguments ]
		ifFalse: [ 
			self nextPutAll: '('.
			self visitNode: aMessageNode receiver.
			self nextPutAll: ' ? '.
			self visitArguments: aMessageNode arguments first lastStmt.
			self nextPutAll: ' : 0)' ]! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/13/2012 04:50'!
translateIfTrueIfFalseFor: aMessageNode
	self nextPutAll: 'if ('.
	self visitNode: aMessageNode receiver.
	self nextPutAll: ') '.
	self visitArguments: aMessageNode arguments first.
	self nextPutAll: ' else '.
	self visitArguments: aMessageNode arguments second! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/20/2012 17:06'!
translateWhileFalseDoFor: aMessageNode
	self nextPutAll: 'while (1) '.
	aMessageNode receiver beFalseBlock.
	aMessageNode arguments first addFirstStmt: aMessageNode receiver.
	self visitArguments: aMessageNode arguments! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/13/2012 04:51'!
translateWhileFalseFor: aMessageNode
	self nextPutAll: 'while (1) '.
	aMessageNode receiver beFalseBlock.
	self visitNode: aMessageNode receiver! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/20/2012 16:58'!
translateWhileTrueDoFor: aMessageNode
	self nextPutAll: 'while (1) '.
	aMessageNode receiver beTrueBlock.
	aMessageNode arguments first addFirstStmt: aMessageNode receiver.
	self visitArguments: aMessageNode arguments! !

!XeMethodTranslator methodsFor: 'C translation' stamp: 'BernardoContreras 5/13/2012 04:51'!
translateWhileTrueFor: aMessageNode
	self nextPutAll: 'while (1) '.
	aMessageNode receiver beTrueBlock.
	self visitNode: aMessageNode receiver! !

!XeMethodTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/12/2012 20:14'!
visitMethodArguments: aNodeCollection
	^ aNodeCollection isEmpty
		ifTrue: [ #void asXeType emitOn: stream ]
		ifFalse: [ aNodeCollection do: [ :each | self visitArgument: each ] separatedBy: [ stream nextPutAll: ', ' ] ]! !

RBProgramNodeVisitor subclass: #XeSemanticAnnotator
	instanceVariableNames: 'scope defaultType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic'!

!XeSemanticAnnotator commentStamp: 'BernardoContreras 4/21/2012 03:20' prior: 0!
To annotate the code with types.

!

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/14/2012 20:45'!
acceptBlockNode: aNode
	self scope: aNode with: XeBlockScope during: [ super acceptBlockNode: aNode ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/14/2012 20:45'!
acceptMethodNode: aNode 
	self scope: aNode with: XeMethodScope during: [ super acceptMethodNode: aNode  ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 5/13/2012 03:37'!
acceptPragmaNode: aPragmaNode
	aPragmaNode isReturnType
		ifTrue: [ 
			aPragmaNode scope hasReturnType
				ifTrue: [ 
					XeTooManyReturnTypesError
						signalForSelector: aPragmaNode parent selector
						returnTypes:
							{(aPragmaNode scope returnType).
							(aPragmaNode returnType)} ]
				ifFalse: [ aPragmaNode scope add: (XeReturnTypeBinding returnType: aPragmaNode returnType) ] ].
	aPragmaNode isVarType
		ifTrue: [ 
			| variableBinding |
			variableBinding := aPragmaNode scope lookup: aPragmaNode varName.
			variableBinding type: aPragmaNode varType ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/21/2012 03:38'!
acceptSequenceNode: aNode
	aNode temporaries do: [ :each | scope add: (XeTemporaryBinding node: each type: defaultType) ].
	aNode statements do: [ :each | self visitNode: each ]! !

!XeSemanticAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/15/2012 01:52'!
acceptVariableNode: aNode
	| binding |
	binding := scope
		lookup: aNode name
		ifAbsent: [ self undeclaredVariable: aNode ].
	aNode propertyAt: #xeVariableBinding put: binding.
	binding addAccessor: aNode.
	aNode isUsed
		ifTrue: [ binding addReader: aNode ].
	aNode isWrite
		ifTrue: [ binding addWriter: aNode ]! !

!XeSemanticAnnotator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/21/2012 03:23'!
initialize
	super initialize.
	defaultType := XeType name: 'sqInt'
	! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:24'!
scope: aNode with: aClass during: aBlock
	scope := aClass owner: scope node: aNode.
	^ aBlock ensure: [ scope := scope owner ]! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode
	self visitNode: aProgramNode methodNode! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/14/2012 20:24'!
start: aProgramNode scope: aLexicalScope
	scope := aLexicalScope.
	self start: aProgramNode! !

!XeSemanticAnnotator methodsFor: 'private' stamp: 'BernardoContreras 4/15/2012 00:53'!
undeclaredVariable: aNode
	^ aNode scope add: (XeUndeclaredVariableNotification node: aNode)! !

!XeSemanticAnnotator methodsFor: 'visiting' stamp: 'BernardoContreras 4/21/2012 03:24'!
visitArgument: aNode
	scope add: (XeArgumentBinding node: aNode type: defaultType)! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/13/2012 03:36'!
isReturnType
	"return true if it is returnType: pragma"

	^ self selector == #returnType:! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/13/2012 02:49'!
isVarType
	"return true if it is var:type: pragma"

	^ self selector == #var:type:! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
returnType
	^ self arguments first value
	! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
varName
	^ self arguments first value! !

!RBPragmaNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:03'!
varType
	^ self arguments second value asXeType! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:13'!
addFirstStmt: aStmt
	^ self statements addFirst: aStmt! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:14'!
addLastStmt: aStmt
	^ self statements addLast: aStmt! !

!RBSequenceNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:14'!
lastStmt
	^ statements last! !

Model subclass: #XeScenarioBrowserUI
	instanceVariableNames: 'scenarioBrowser actual expected diff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-UI'!

!XeScenarioBrowserUI commentStamp: 'BernardoContreras 5/6/2012 19:42' prior: 0!
Knows how to display a scenario in the UI
Instance Variables:
actual
	- the actual translation
diff
	- the diff between the actual and the expected translation
expected
	-  the expected translation
scenarioBrowser
	- the scenario to browse
	
!

!XeScenarioBrowserUI class methodsFor: 'instance creation' stamp: 'BernardoContreras 5/5/2012 23:05'!
on: aScenarioBrowser 
	^ self new on: aScenarioBrowser.! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 5/5/2012 23:14'!
actualContents
	^ scenarioBrowser actualContents 
	! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/6/2012 02:31'!
addActualTo: window
	| label |
	label := LabelMorph contents: 'Actual'.
	label font: StandardFonts defaultFont emphasis: 1.
	window addMorph: label frame: (0.6 @ 0 corner: 1 @ 0.03).
	actual := PluggableTextMorph on: self text: #actualContents accept: nil.
	actual disable.
	window addMorph: actual frame: (0.6 @ 0.03 corner: 1 @ 0.90)! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/6/2012 02:31'!
addDiffTo: window
	| label |
	label := LabelMorph contents: 'Diff'.
	label font: StandardFonts defaultFont emphasis: 1.
	window addMorph: label frame: (0.3 @ 0 corner: 0.6 @ 0.03).
	diff := PluggableTextMorph on: self text: #diffContents accept: nil.
	diff disable.
	window addMorph: diff frame: (0.3 @ 0.03 corner: 0.6 @ 0.90)! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/6/2012 02:31'!
addExpectedTo: window
	| label |
	label := LabelMorph contents: 'Expected'.
	label font: StandardFonts defaultFont emphasis: 1.
	window addMorph: label frame: (0 @ 0 corner: 0.3 @ 0.03).
	expected := PluggableTextMorph on: self text: #expectedContents accept: nil.
	expected disable.
	window addMorph: expected frame: (0 @ 0.03 corner: 0.3 @ 0.90)! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/6/2012 02:31'!
addRefreshButtonTo: window
	window
		addMorph:
			(PluggableButtonMorph
				on: self
				getState: nil
				action: #refreshButtonAction
				label: #refreshButtonLabel)
		frame: (0 @ 0.90 corner: 1 @ 1)! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/6/2012 19:45'!
buildWindow
	| window |
	window := (SystemWindow labelled: scenarioBrowser asString) model: self.
	self addExpectedTo: window.
	self addActualTo: window.
	self addDiffTo: window.
	self addRefreshButtonTo: window.
	^ window! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 5/6/2012 02:24'!
diffContents
	^ TextDiffBuilder buildDisplayPatchFrom: actual getText to: expected getText! !

!XeScenarioBrowserUI methodsFor: 'accessing' stamp: 'BernardoContreras 5/5/2012 23:14'!
expectedContents
	^ scenarioBrowser expectedContents! !

!XeScenarioBrowserUI methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/5/2012 23:16'!
on: aScenarioBrowser 
	scenarioBrowser := aScenarioBrowser.

	! !

!XeScenarioBrowserUI methodsFor: 'display' stamp: 'BernardoContreras 5/5/2012 23:17'!
open
	self buildWindow openInWorld 
	! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 5/6/2012 02:28'!
refreshButtonAction
	expected update: #expectedContents.
	actual update: #actualContents.
	diff update: #diffContents! !

!XeScenarioBrowserUI methodsFor: 'button behavior' stamp: 'BernardoContreras 5/6/2012 01:46'!
refreshButtonLabel
	^ 'Refresh'! !

!True methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:37'!
asCLiteralValue
	^ '1'! !

!RBMessageNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/9/2012 03:59'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 16:59'!
addFirstStmt: aStmt
	^ self body addFirstStmt: aStmt! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/20/2012 17:13'!
addLastStmt: aStmt
	^ self body addLastStmt: aStmt! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 23:48'!
beFalseBlock
	self propertyAt: #xeConditionalBlock put: #FalseBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:28'!
beTrueBlock
	self propertyAt: #xeConditionalBlock put: #TrueBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:16'!
isConditionalBlock
	^ self hasProperty: #xeConditionalBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/30/2012 21:27'!
isTrueBlock
	^ (self propertyAt: #xeConditionalBlock) == #TrueBlock! !

!RBBlockNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/16/2012 22:43'!
lastStmt
	^ self body lastStmt.! !

!False methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 19:50'!
asCLiteralValue
	^ '0'! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/25/2012 16:56'!
hasXeVariableBinding
	^ self hasProperty: #xeVariableBinding! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 5/13/2012 03:55'!
type
	^ (self scope lookup: self name) type! !

!RBVariableNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:51'!
xeVariableBinding
	^ self propertyAt: #xeVariableBinding ifAbsent: [ self xeSemanticAnnotationMissing ]! !

Error subclass: #XeSemanticAnnotationMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeSemanticAnnotationMissing commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSemanticAnnotationMissing methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 21:13'!
isResumable
	^ true! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/25/2012 02:51'!
signalForSelector: aSelectorName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , '. actual types: ' , anArray asString.
	^ self signal: message! !

!UndefinedObject methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 20:20'!
asCLiteralValue
	^ 'null'
	! !

!Character methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/22/2012 04:20'!
asCLiteralValue
	^ '''' , self asString , ''''! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 00:46'!
scope
	^ self propertyAt: #scope ifAbsent: [ 
		self parent isNil
			ifFalse: [ self parent scope ]
			ifTrue: [ self xeSemanticAnnotationMissing ] ]! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 01:33'!
xeAnnotateInClass: aBehavior
	XeSemanticAnnotator new
		start: self
		scope: (XeVariableScope owner: (XeLiteralScope owner: XeRootScope new class: aBehavior) class: aBehavior)! !

!RBProgramNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/15/2012 02:47'!
xeSemanticAnnotationMissing
	XeSemanticAnnotationMissing signal: 'Semantic annotation missing, please use #xeAnnotateInClass: to annotate the AST'! !

!Object methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/11/2012 04:36'!
asCLiteralValue
	self subclassResponsibility! !

Object subclass: #XeCodeGenerator
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeCodeGenerator commentStamp: '<historical>' prior: 0!
To generate C code from a reduced Smalltalk code.

* Constants are translated only if they are binded in a method.
!

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/15/2012 01:34'!
addClass: aClass
	aClass
		methodsDo: [ :method | methods add: ((self parserClass parseMethod: method getSource) xeAnnotateInClass: aClass) ]! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/21/2012 03:07'!
codeString
	| stream |
	stream := ReadWriteStream on: (String new: 1000).
	self sortMethods.
	self translateOn: stream.
	^ stream contents! !

!XeCodeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/6/2012 19:28'!
initialize
	super initialize.
	methods := OrderedCollection new.! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 06:58'!
sortMethods
	methods sort: [ :a :b | a selector caseSensitiveLessOrEqual: b selector ]! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:17'!
translateOn: aStream
	| translator |
	translator := self translatorClass newFor: aStream.
	translator translate: methods! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !

Object subclass: #XeExpected
	instanceVariableNames: 'stream indentationLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Util'!

!XeExpected commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
To describe what it is expected as a result of the translation.
!

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 02:57'!
<< aCollection
	stream tab: indentationLevel.
	stream
		nextPutAll: aCollection;
		cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 03:05'!
contents
	^ stream contents! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 05:08'!
functionPrototypesComment
	self << '/*** Function Prototypes ***/'! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 03:00'!
indentation: aNumber
	indentationLevel := aNumber! !

!XeExpected methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 02:55'!
initialize
	stream := WriteStream on: (String new: 1000).
	indentationLevel := 0! !

!XeExpected methodsFor: 'printing' stamp: 'BernardoContreras 4/7/2012 04:00'!
printOn: aStream
	aStream nextPutAll: 'expects '.
	aStream
		nextPut: $[;
		cr.
	aStream nextPutAll: stream contents.
	aStream nextPut: $]! !

Object subclass: #XeLexicalScope
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLexicalScope commentStamp: 'BernardoContreras 5/12/2012 22:59' prior: 0!
stolen from AST-Semantic!

!XeLexicalScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:27'!
new
	^ self basicNew initialize! !

!XeLexicalScope methodsFor: 'adding' stamp: 'BernardoContreras 4/15/2012 02:48'!
add: aVariableBinding
	"Add aVariableBinding to the receiving scope."

	^ bindings at: aVariableBinding name put: (aVariableBinding setScope: self)! !

!XeLexicalScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 20:27'!
basicBindingOf: aString
	^ nil! !

!XeLexicalScope methodsFor: 'binding' stamp: 'BernardoContreras 4/14/2012 20:27'!
bindingOf: aString
	"Answer the local binding of aString or nil."
	
	^ bindings at: aString ifAbsent: [
		| binding |
		binding := (self basicBindingOf: aString) 
			ifNil: [ ^ nil ].
		self add: binding ]! !

!XeLexicalScope methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/30/2012 21:05'!
initialize
	bindings := RBSmallDictionary new! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isBlockScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isLiteralScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isMethodScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isRootScope
	^ false! !

!XeLexicalScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:27'!
isVariableScope
	^ false! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString
	"Lookup the variable aString in the receiving scope, throw an error if not found."

	^ self lookup: aString ifAbsent: [ self error: 'No binding for ' , aString printString , ' found.' ]! !

!XeLexicalScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:27'!
lookup: aString ifAbsent: aBlock
	"Lookup the variable aString in the receiving scope, evaluate aBlock if not found."

	self subclassResponsibility! !

XeLexicalScope subclass: #XeOwnedScope
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeOwnedScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeOwnedScope subclass: #XeClassScope
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeClassScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeClassScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:30'!
owner: aLexicalScope class: aBehavior
	^ (self owner: aLexicalScope) setClass: aBehavior! !

!XeClassScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:30'!
setClass: aBehavior
	class := aBehavior! !

!XeClassScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:30'!
theClass
	^ class! !

XeClassScope subclass: #XeLiteralScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeLiteralScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeLiteralScope methodsFor: 'private' stamp: 'BernardoContreras 4/14/2012 21:10'!
basicBindingOf: aString
	^ (class bindingOf: aString) ifNotNil: [ :binding | XeLiteralBinding binding: binding ]! !

!XeLiteralScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:31'!
isLiteralScope
	^ true! !

XeClassScope subclass: #XeVariableScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeVariableScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeVariableScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:37'!
isVariableScope
	^ true! !

!XeVariableScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 21:11'!
setClass: aClass
	super setClass: aClass.
	aClass allInstVarNames 
		keysAndValuesDo: [ :index :name | self add: (XeInstanceBinding name: name index: index) ]! !

XeOwnedScope subclass: #XeNodedScope
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeNodedScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeNodedScope subclass: #XeBlockScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeBlockScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeBlockScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:39'!
isBlockScope
	^ true! !

XeNodedScope subclass: #XeMethodScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeMethodScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeMethodScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:40'!
isMethodScope
	^ true! !

!XeNodedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:38'!
owner: aLexicalScope node: aProgramNode
	^ (self owner: aLexicalScope) setNode: aProgramNode! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 5/26/2012 00:29'!
hasReturnType
	self lookup: 'returnType' ifAbsent: [ ^ false ].
	^ true! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:38'!
node
	"Answer the program node that defines this scope."
	
	^ node! !

!XeNodedScope methodsFor: 'accessing' stamp: 'BernardoContreras 5/26/2012 00:28'!
returnType
	^ (self lookup: 'returnType' ifAbsent: [ #sqInt ]) asXeType! !

!XeNodedScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/15/2012 00:53'!
setNode: aProgramNode
	node := aProgramNode.
	node propertyAt: #scope put: self! !

!XeOwnedScope class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner: aLexicalScope
	^ self new setOwner: aLexicalScope! !

!XeOwnedScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:28'!
lookup: aString ifAbsent: aBlock
	^ (self bindingOf: aString) ifNil: [ owner lookup: aString ifAbsent: aBlock ]! !

!XeOwnedScope methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:28'!
owner
	"Answer the owning scope."

	^ owner! !

!XeOwnedScope methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:28'!
setOwner: aLexicalScope
	owner := aLexicalScope! !

XeLexicalScope subclass: #XeRootScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Scope'!

!XeRootScope commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

!XeRootScope methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 21:11'!
initialize
	super initialize.
	self add: XeSelfBinding new.
	self add: XeSuperBinding new.
	self add: XeContextBinding new! !

!XeRootScope methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:42'!
isRootScope
	^ true! !

!XeRootScope methodsFor: 'querying' stamp: 'BernardoContreras 4/14/2012 20:42'!
lookup: aString ifAbsent: aBlock
	^ bindings at: aString ifAbsent: aBlock! !

Object subclass: #XeScenarioBrowser
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-UI'!

!XeScenarioBrowser commentStamp: 'BernardoContreras 5/6/2012 02:33' prior: 0!
Browse a scenario, and see what the expected translation is, 
what the actual translation is and the diff between them.
Usage:
  XeScenarioBrowser browse: XeWhileTrueScenario 
!

!XeScenarioBrowser class methodsFor: 'instance creation' stamp: 'BernardoContreras 5/5/2012 18:21'!
browse: aScenarioClass 
	^self new browse: aScenarioClass! !

!XeScenarioBrowser methodsFor: 'accessing' stamp: 'BernardoContreras 5/5/2012 19:06'!
actualContents
	^ self codeString! !

!XeScenarioBrowser methodsFor: 'initialize-release' stamp: 'BernardoContreras 5/5/2012 23:11'!
browse: aScenarioClass
	scenario := aScenarioClass.
	^ (self uiClass on: self) open! !

!XeScenarioBrowser methodsFor: 'private' stamp: 'BernardoContreras 5/6/2012 00:11'!
codeString
	| cg |
	cg := XeCodeGenerator new.
	cg addClass: scenario.
	^ cg codeString! !

!XeScenarioBrowser methodsFor: 'accessing' stamp: 'BernardoContreras 5/5/2012 19:13'!
expectedContents
	^ scenario expected contents! !

!XeScenarioBrowser methodsFor: 'printing' stamp: 'BernardoContreras 5/6/2012 00:17'!
printOn: aStream
	aStream nextPutAll: 'browsing: '.
	aStream nextPutAll: scenario asString! !

!XeScenarioBrowser methodsFor: 'private' stamp: 'BernardoContreras 5/6/2012 00:11'!
uiClass
	^ XeScenarioBrowserUI! !

Object subclass: #XeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Translators'!

!XeTranslator commentStamp: 'BernardoContreras 4/5/2012 15:50' prior: 0!
To translate to C Code on a stream
!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 06:58'!
newFor: aStream
	" a new instance for the given stream"

	^ self new
		stream: aStream;
		yourself! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
functionPrototypeTranslatorClass
	^ XeFunctionPrototypeTranslator 
	! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:31'!
methodTranslatorClass
	^ XeMethodTranslator
	 
	! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 06:58'!
stream: aStream
	stream := aStream! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 02:36'!
translate: methods
	self translateFunctionPrototypesFor: methods.
	self translateMethodsFor: methods! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:34'!
translateFunctionPrototypesFor: methods
	| translator |
	stream
		nextPutAll: '/*** Function Prototypes ***/';
		cr.
	translator := self functionPrototypeTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/7/2012 02:35'!
translateMethodsFor: methods
	| translator |
	translator := self methodTranslatorClass newFor: stream.
	methods do: [ :each | translator visitNode: each ]! !

Object subclass: #XeType
	instanceVariableNames: 'typename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

!XeType class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/22/2012 01:39'!
name: aString 
	^ self new typename: aString.! !

!XeType methodsFor: 'comparing' stamp: 'BernardoContreras 4/22/2012 01:38'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ typename = anObject typename! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 4/22/2012 01:38'!
emitOn: aStream
	"emit the string representation of this type on a stream"

	aStream nextPutAll: typename! !

!XeType methodsFor: 'comparing' stamp: 'BernardoContreras 4/22/2012 01:38'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ typename hash! !

!XeType methodsFor: 'printing' stamp: 'BernardoContreras 4/22/2012 01:38'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' named: ';
		nextPutAll: typename! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 4/22/2012 01:38'!
typename
	^ typename! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 4/22/2012 01:39'!
typename: aString 
	typename := aString! !

Object subclass: #XeVariableBinding
	instanceVariableNames: 'scope accessors readers writers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeVariableBinding commentStamp: 'BernardoContreras 5/12/2012 23:00' prior: 0!
stolen from AST-Semantic!

XeVariableBinding subclass: #XeInstanceBinding
	instanceVariableNames: 'name index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeInstanceBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeInstanceBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:54'!
name: aString index: anInteger
	^ self new initializeName: aString index: anInteger! !

!XeInstanceBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:54'!
index
	^ index! !

!XeInstanceBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:54'!
initializeName: aString index: anInteger
	name := aString.
	index := anInteger! !

!XeInstanceBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:54'!
isInstanceBinding
	^ true! !

!XeInstanceBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:54'!
name
	^ name! !

XeVariableBinding subclass: #XeLiteralBinding
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeLiteralBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeLiteralBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding: aBinding
	^ self new initializeBinding: aBinding! !

!XeLiteralBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:55'!
binding
	^ binding! !

!XeLiteralBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/14/2012 20:55'!
initializeBinding: aBinding
	binding := aBinding! !

!XeLiteralBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:55'!
isLiteralBinding
	^ true! !

!XeLiteralBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:55'!
name
	^ binding key asString! !

XeVariableBinding subclass: #XeLocalBinding
	instanceVariableNames: 'node type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeLocalBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

XeLocalBinding subclass: #XeArgumentBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeArgumentBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeArgumentBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isArgumentBinding
	^ true! !

!XeArgumentBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:57'!
isReadonly
	^ true! !

!XeLocalBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:56'!
node: aNode
	^ self new setNode: aNode! !

!XeLocalBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/21/2012 03:43'!
node: aNode type: type
	^ self new
		setNode: aNode;
		type: type;
		yourself! !

!XeLocalBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:56'!
name
	^ node name! !

!XeLocalBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:56'!
node
	"Answer the declaring or defining node."
	
	^ node! !

!XeLocalBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/15/2012 01:52'!
setNode: aNode
	node := aNode.
	node propertyAt: #xeVariableBinding put: self! !

!XeLocalBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/21/2012 03:37'!
type
	"Answer the type of the binding."

	^ type! !

!XeLocalBinding methodsFor: 'initialization' stamp: 'BernardoContreras 4/21/2012 03:43'!
type: aType
	type := aType.
! !

XeLocalBinding subclass: #XeTemporaryBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeTemporaryBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeTemporaryBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:57'!
isTemporaryBinding
	^ true! !

XeLocalBinding subclass: #XeUndeclaredBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeUndeclaredBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeUndeclaredBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:01'!
isUndeclaredBinding
	^ true! !

XeVariableBinding subclass: #XeReturnTypeBinding
	instanceVariableNames: 'returnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeReturnTypeBinding commentStamp: 'BernardoContreras 4/14/2012 20:49' prior: 0!
To bind the return type of  a method
!

!XeReturnTypeBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/13/2012 01:23'!
returnType: typeName
	^ self new
		returnType: typeName;
		yourself! !

!XeReturnTypeBinding methodsFor: 'converting' stamp: 'BernardoContreras 4/13/2012 02:27'!
asXeType
	^ returnType asXeType
	! !

!XeReturnTypeBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 02:12'!
name
	"Answer the name of the variable."

	^ 'returnType'! !

!XeReturnTypeBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/13/2012 01:24'!
returnType: typeName
 	returnType := typeName! !

XeVariableBinding subclass: #XeSpecialBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSpecialBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

XeSpecialBinding subclass: #XeContextBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeContextBinding commentStamp: 'BernardoContreras 5/12/2012 23:01' prior: 0!
stolen from AST-Semantic!

!XeContextBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isContextBinding
	^ true! !

!XeContextBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'thisContext'! !

XeSpecialBinding subclass: #XeSelfBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSelfBinding commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSelfBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSelfBinding
	^ true! !

!XeSelfBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'self'! !

!XeSpecialBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:02'!
isReadonly
	^ true! !

XeSpecialBinding subclass: #XeSuperBinding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Semantic-Binding'!

!XeSuperBinding commentStamp: 'BernardoContreras 5/12/2012 23:02' prior: 0!
stolen from AST-Semantic!

!XeSuperBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 21:03'!
isSuperBinding
	^ true! !

!XeSuperBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 21:03'!
name
	^ 'super'! !

!XeVariableBinding class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/14/2012 20:49'!
new
	^ self basicNew initialize! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
accessors
	"Answer the nodes that access the receiver."
	
	^ accessors! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addAccessor: aProgramNode
	accessors := accessors copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addReader: aProgramNode
	readers := readers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'protected' stamp: 'BernardoContreras 4/14/2012 20:49'!
addWriter: aProgramNode
	writers := writers copyWith: aProgramNode! !

!XeVariableBinding methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 20:49'!
initialize
	accessors := readers := writers := #()! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isAccessed
	"Answer true if the receiving binding is accessed."
	
	^ self accessors notEmpty! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isArgumentBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isContextBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isInstanceBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isLiteralBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isRead
	"Answer true if the receiving binding is read."
	
	^ self readers notEmpty! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isReadonly
	"Answer if the receiving binding is readonly."

	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSelfBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isShadowing
	"Answer true if the receiving shadows another variable in a parent scope."

	self scope isRootScope
		ifTrue: [ ^ false ].
	self scope owner
		lookup: self name
		ifAbsent: [ ^ false ].
	^ true! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isSuperBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isTemporaryBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing-type' stamp: 'BernardoContreras 4/14/2012 20:49'!
isUndeclaredBinding
	^ false! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
isWritten
	"Answer true if the receiving binding is written."
	
	^ self writers notEmpty! !

!XeVariableBinding methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 20:49'!
name
	"Answer the name of the variable."
	
	self subclassResponsibility! !

!XeVariableBinding methodsFor: 'printing' stamp: 'BernardoContreras 4/14/2012 20:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
readers
	"Answer the nodes that read from the receiver."
	
	^ readers! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
scope
	"Answer the owning scope."
	
	^ scope! !

!XeVariableBinding methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 20:49'!
setScope: aLexicalScope
	scope := aLexicalScope! !

!XeVariableBinding methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 20:49'!
writers
	"Answer the nodes that write to the receiver."
	
	^ writers! !
